----------------------------------------------------------------------------------------------
--
--
--      Input file         : C:/Download/_Halbleiter/Altera/terasic/DE0_Nano_v1.0.5_SystemCD/Demonstration/DE0_NANO_GSensor.vhdl/DE0_NANO_G_Sensor.v
--      Design name        : DE0_NANO_G_Sensor
--      Author             : 
--      Company            : 
--
--      Description        : 
--
--
----------------------------------------------------------------------------------------------
--
-- --------------------------------------------------------------------
-- Copyright (c) 2011 by Terasic Technologies Inc. 
-- --------------------------------------------------------------------
--
-- Permission:
--
--   Terasic grants permission to use and modify this code for use
--   in synthesis for all Terasic Development Boards and Altera Development 
--   Kits made by Terasic.  Other use of this code, including the selling 
--   ,duplication, or modification of any portion is strictly prohibited.
--
-- Disclaimer:
--
--   This VHDL/Verilog or C/C++ source code is intended as a design reference
--   which illustrates how these types of functions can be implemented.
--   It is the user's responsibility to verify their design for
--   consistency and functionality through the use of formal
--   verification methods.  Terasic provides no warranty regarding the use 
--   or functionality of this code.
--
-- --------------------------------------------------------------------
--           
--                     Terasic Technologies Inc
--                     356 Fu-Shin E. Rd Sec. 1. JhuBei City,
--                     HsinChu County, Taiwan
--                     302
--
--                     web: http://www.terasic.com/
--                     email: support@terasic.com
--
-- --------------------------------------------------------------------
--
-- Major Functions:	G Sensor utilization
--
-- --------------------------------------------------------------------
--
-- Revision History :
-- --------------------------------------------------------------------
--   Ver  :| Author              :| Mod. Date   :| Changes Made:
--   V1.0 :| Rosaline Lin        :| 02/16/2011  :| Initial Revision
-- --------------------------------------------------------------------
--=======================================================
--  This code is generated by Terasic System Builder
--=======================================================
LIBRARY IEEE;
USE IEEE.std_logic_1164.all;

ENTITY DE0_NANO_G_Sensor IS
   PORT (
      CLOCK_50                : IN std_logic;   
      LED                     : OUT std_logic_vector(7 DOWNTO 0);   
      KEY                     : IN std_logic_vector(1 DOWNTO 0);   
      G_SENSOR_CS_N           : OUT std_logic;   
      G_SENSOR_INT            : IN std_logic;   
      I2C_SCLK                : OUT std_logic;   
      I2C_SDAT                : INOUT std_logic);   
END DE0_NANO_G_Sensor;

ARCHITECTURE translated OF DE0_NANO_G_Sensor IS


   --=======================================================
   --  REG/WIRE declarations
   --=======================================================
   SIGNAL dly_rst                  :  std_logic;   
   SIGNAL spi_clk                  :  std_logic;   
   SIGNAL spi_clk_out              :  std_logic;   
   SIGNAL data_x                   :  std_logic_vector(15 DOWNTO 0);   
   SIGNAL LED_xhdl1                :  std_logic_vector(7 DOWNTO 0);   
   SIGNAL G_SENSOR_CS_N_xhdl2      :  std_logic;   
   SIGNAL I2C_SCLK_xhdl3           :  std_logic;   

BEGIN
   LED <= LED_xhdl1;
   G_SENSOR_CS_N <= G_SENSOR_CS_N_xhdl2;
   I2C_SCLK <= I2C_SCLK_xhdl3;
   -- <<X-HDL>> Can't find translated component 'reset_delay'. Port & generic names and types may not match. No template will be included
   u_reset_delay : entity work.reset_delay 
      PORT MAP (
         iRSTN => KEY(0),
         iCLK => CLOCK_50,
         oRST => dly_rst);   
   
   -- <<X-HDL>> Can't find translated component 'spipll'. Port & generic names and types may not match. No template will be included
   u_spipll : entity work.spipll 
      PORT MAP (
         areset => dly_rst,
         inclk0 => CLOCK_50,
         c0 => spi_clk,
         c1 => spi_clk_out);   
   
   -- <<X-HDL>> Can't find translated component 'spi_ee_config'. Port & generic names and types may not match. No template will be included
   u_spi_ee_config : entity work.spi_ee_config 
      PORT MAP (
         iRSTN => NOT dly_rst,
         iSPI_CLK => spi_clk,
         iSPI_CLK_OUT => spi_clk_out,
         iG_INT2 => G_SENSOR_INT,
         oDATA_L => data_x(7 DOWNTO 0),
         oDATA_H => data_x(15 DOWNTO 8),
         SPI_SDIO => I2C_SDAT,
         oSPI_CSN => G_SENSOR_CS_N_xhdl2,
         oSPI_CLK => I2C_SCLK_xhdl3);   
   
   -- <<X-HDL>> Can't find translated component 'led_driver'. Port & generic names and types may not match. No template will be included
   u_led_driver : entity work.led_driver 
      PORT MAP (
         iRSTN => NOT dly_rst,
         iCLK => CLOCK_50,
         iDIG => data_x(9 DOWNTO 0),
         iG_INT2 => G_SENSOR_INT,
         oLED => LED_xhdl1);   
   

END translated;
