----------------------------------------------------------------------------------------------
--
--
--      Input file         : C:/Download/_Halbleiter/Altera/terasic/DE0_Nano_v1.0.5_SystemCD/Demonstration/DE0_NANO_GSensor.vhdl/v/led_driver.v
--      Design name        : led_driver
--      Author             : 
--      Company            : 
--
--      Description        : 
--
--
----------------------------------------------------------------------------------------------
--
LIBRARY IEEE;
USE IEEE.std_logic_1164.all;
USE IEEE.std_logic_unsigned.all;

ENTITY led_driver IS
   PORT (
      iRSTN                   : IN std_logic;   
      iCLK                    : IN std_logic;   
      iDIG                    : IN std_logic_vector(9 DOWNTO 0);   
      iG_INT2                 : IN std_logic;   
      oLED                    : OUT std_logic_vector(7 DOWNTO 0));   
END led_driver;

ARCHITECTURE translated OF led_driver IS


   --=======================================================
   --  REG/WIRE declarations
   --=======================================================
   SIGNAL select_data              :  std_logic_vector(4 DOWNTO 0);   
   SIGNAL signed_bit               :  std_logic;   
   SIGNAL abs_select_high          :  std_logic_vector(3 DOWNTO 0);   
   SIGNAL int2_d                   :  std_logic_vector(1 DOWNTO 0);   
   SIGNAL int2_count               :  std_logic_vector(23 DOWNTO 0);   
   SIGNAL int2_count_en            :  std_logic;   
   -- +-2g resolution : 10-bit
   --=======================================================
   --  Structural coding
   --=======================================================
   SIGNAL temp_xhdl2               :  std_logic_vector(8 DOWNTO 4);   
   SIGNAL temp_xhdl3               :  std_logic_vector(4 DOWNTO 0);   
   SIGNAL temp_xhdl4               :  std_logic_vector(8 DOWNTO 4);   
   SIGNAL temp_xhdl5               :  std_logic_vector(9 DOWNTO 5);   
   SIGNAL temp_xhdl6               :  std_logic_vector(3 DOWNTO 0);   
   SIGNAL temp_xhdl7               :  std_logic_vector(7 DOWNTO 0);   
   SIGNAL temp_xhdl8               :  std_logic_vector(7 DOWNTO 0);   
   SIGNAL temp_xhdl9               :  std_logic_vector(7 DOWNTO 0);   
   SIGNAL temp_xhdl10              :  std_logic_vector(7 DOWNTO 0);   
   SIGNAL temp_xhdl11              :  std_logic_vector(7 DOWNTO 0);   
   SIGNAL temp_xhdl12              :  std_logic_vector(7 DOWNTO 0);   
   SIGNAL temp_xhdl13              :  std_logic_vector(7 DOWNTO 0);   
   SIGNAL temp_xhdl14              :  std_logic_vector(7 DOWNTO 0);   
   SIGNAL temp_xhdl15              :  std_logic_vector(7 DOWNTO 0);   
   SIGNAL temp_xhdl16              :  std_logic_vector(7 DOWNTO 0);   
   SIGNAL temp_xhdl17              :  std_logic_vector(7 DOWNTO 0);   
   SIGNAL temp_xhdl18              :  std_logic_vector(7 DOWNTO 0);   
   SIGNAL temp_xhdl19              :  std_logic_vector(7 DOWNTO 0);   
   SIGNAL temp_xhdl20              :  std_logic_vector(7 DOWNTO 0);   
   SIGNAL temp_xhdl21              :  std_logic_vector(7 DOWNTO 0);   
   SIGNAL temp_xhdl22              :  std_logic_vector(7 DOWNTO 0);   
   SIGNAL oLED_xhdl1               :  std_logic_vector(7 DOWNTO 0);   

BEGIN
   oLED <= oLED_xhdl1;
   temp_xhdl2 <= iDIG(8 DOWNTO 4) WHEN iDIG(8) = '1' ELSE "10000";
   temp_xhdl3 <= "01111" WHEN iDIG(8) = '1' ELSE iDIG(8 DOWNTO 4);
   temp_xhdl4 <= (temp_xhdl2) WHEN iDIG(9) = '1' ELSE (temp_xhdl3);
   temp_xhdl5 <= iDIG(9 DOWNTO 5) WHEN iG_INT2 = '1' ELSE (temp_xhdl4);
   select_data <= temp_xhdl5 ;
   signed_bit <= select_data(4) ;
   temp_xhdl6 <= NOT select_data(3 DOWNTO 0) WHEN signed_bit = '1' ELSE select_data(3 DOWNTO 0);
   abs_select_high <= temp_xhdl6 ;
   temp_xhdl7 <= "00001000" WHEN signed_bit = '1' ELSE "00010000";
   temp_xhdl8 <= "00001100" WHEN signed_bit = '1' ELSE "00110000";
   temp_xhdl9 <= "00000100" WHEN signed_bit = '1' ELSE "00100000";
   temp_xhdl10 <= "00000110" WHEN signed_bit = '1' ELSE "01100000";
   temp_xhdl11 <= "00000010" WHEN signed_bit = '1' ELSE "01000000";
   temp_xhdl12 <= "00000011" WHEN signed_bit = '1' ELSE "11000000";
   temp_xhdl13 <= "00000001" WHEN signed_bit = '1' ELSE "10000000";
   temp_xhdl14 <= (temp_xhdl12) WHEN (abs_select_high(3 DOWNTO 1) = "110") ELSE (temp_xhdl13);
   temp_xhdl15 <= (temp_xhdl11) WHEN (abs_select_high(3 DOWNTO 1) = "101") ELSE temp_xhdl14;
   temp_xhdl16 <= (temp_xhdl10) WHEN (abs_select_high(3 DOWNTO 1) = "100") ELSE temp_xhdl15;
   temp_xhdl17 <= (temp_xhdl9) WHEN (abs_select_high(3 DOWNTO 1) = "011") ELSE temp_xhdl16;
   temp_xhdl18 <= (temp_xhdl8) WHEN (abs_select_high(3 DOWNTO 1) = "010") ELSE temp_xhdl17;
   temp_xhdl19 <= (temp_xhdl7) WHEN (abs_select_high(3 DOWNTO 1) = "001") ELSE temp_xhdl18;
   temp_xhdl20 <= "00011000" WHEN (abs_select_high(3 DOWNTO 1) = "000") ELSE temp_xhdl19;
   temp_xhdl21 <= "00000000" WHEN int2_count(20) = '1' ELSE "11111111";
   temp_xhdl22 <= (temp_xhdl20) WHEN int2_count(23) = '1' ELSE (temp_xhdl21);
   oLED_xhdl1 <= temp_xhdl22 ;

   PROCESS (iRSTN, iCLK)
   BEGIN
      IF (iRSTN = '0') THEN
         int2_count_en <= '0';    
         int2_count <= "100000000000000000000000";    
      ELSIF rising_edge(iCLK) THEN
         int2_d <= int2_d(0) & iG_INT2;    
         IF ((NOT int2_d(1) AND int2_d(0)) = '1') THEN
            int2_count_en <= '1';    
            int2_count <= "000000000000000000000000";    
         ELSE
            IF (int2_count(23) = '1') THEN
               int2_count_en <= '0';    
            ELSE
               int2_count <= int2_count + "000000000000000000000001";    
            END IF;
         END IF;
      END IF;
   END PROCESS;

END translated;
